SystemOrganization addCategory: #'DAO-TP-Changes-Server'!

Object subclass: #SistemaDeCambiosInterfazTCP_Server
	instanceVariableNames: 'connectionSocket isRunning isRunningLock listenPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DAO-TP-Changes-Server'!

!SistemaDeCambiosInterfazTCP_Server class methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:33'!
listenOn: aPort
	aPort isInteger
		ifTrue: [ 
			^self new initializeWith: aPort.
		]
		ifFalse: [ 
			Exception new signal: 'Puerto invlido'.
		]
 ! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:29'!
initialize
	super initialize.
	isRunningLock := Mutex new.
	self isRunning: false.
	listenPort := 9999.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:30'!
initializeWith: aPort
	listenPort := aPort.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:36'!
interactOnConnection 
	| interactionSocket |
	interactionSocket := connectionSocket waitForAcceptFor: 1 ifTimedOut: [^self].
	[self interactUsing: interactionSocket] fork.! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 23:02'!
interactUsing: interactionSocket
| receivedData interactionStream|
[
	interactionStream :=  SocketStream on: interactionSocket.
	"receivedData := interactionSocket receiveDataTimeout: 5."
	receivedData := interactionStream upToAll: ';;;;'.
	receivedData crLog.
	receivedData inspect.
	interactionStream sendCommand: 'OK ;-p'.
] ensure: [ interactionSocket closeAndDestroy ]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:22'!
isRunning
	^isRunningLock critical: [ isRunning ].! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:23'!
isRunning: aBoolean
	^isRunningLock critical: [ isRunning := aBoolean ].! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:26'!
serve
	[ [ self isRunning ]
		whileTrue: [ self interactOnConnection ] ]
		ensure: [ connectionSocket closeAndDestroy ]! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:29'!
start
	isRunningLock critical: [
		self isRunning ifTrue: [ ^ self ].
		self isRunning: true].
	connectionSocket := Socket newTCP.
	connectionSocket listenOn: listenPort backlogSize: 10.
	[ self serve ] fork! !

!SistemaDeCambiosInterfazTCP_Server methodsFor: 'as yet unclassified' stamp: 'SebaServer 12/2/2013 21:25'!
stop
	isRunning := false.! !
